<template>
    <div class="node alias-add-tree-node d-flex flex-row justify-content-start"
        :class="{ 'is-secondary': !node.isPrimary }"
        :data-alias-id="node.alias.id"
        :id="'node_' + node.nodeId">
        <div>
            <span v-if="node.children && node.children.length > 0"
                @click="this.$emit('nodeToggleClicked')">
                <svg v-if="node.$folded" xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-plus" viewBox="0 0 16 16">
                    <path d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4z"/>
                </svg>
                <svg v-else xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-dash" viewBox="0 0 16 16">
                    <path d="M4 8a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7A.5.5 0 0 1 4 8z"/>
                </svg>
            </span>
            <span v-else style="margin-right: 16px"></span>
        </div>
        <div class="flex-fill">
            <div v-if="editMode && node.isPrimary">
                <input class="form-check-input" type="checkbox" v-model="node.alias.isDisplayed">
                <textarea class="form-control form-control-sm node-input-element"
                    rows="1"
                    v-model="node.alias.name"/>
                <BudgetCodesDropdown
                    class="mt-2 node-input-element"
                    :id="'codes-dropdown-' + node.nodeId"
                    :codesList="codesList"
                    v-model:selectedCodeId="node.alias.codeId"/>
                
            </div>
            <div v-else>
                <input class="form-check-input" type="checkbox" v-model="node.alias.isDisplayed" disabled>
                <small class="ms-1">{{node.alias.name}}</small>
                <div v-if="node.alias.codeNumber">
                    <span>{{node.alias.codeNumber}}</span>
                </div>
            </div>
            <small v-if="!node.isPrimary && !node.hasParent" class="node-warning">Копия не имеет связей и исчезнет при обновлении</small>
            <small v-if="node.isPrimary && node.hasCopy" class="node-warning">Псевдоним имеет копию</small>
        </div>
        <div v-if="editMode" class="float-right button-block">
            <button v-if="node.isPrimary" type="button" class="btn btn-block btn-sm btn-outline-secondary zero-height-button d-block mb-2 ms-auto"
                @click="this.$emit('nodeCopyClicked')">
                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-plus-square" viewBox="0 0 16 16">
                    <path fill-rule="evenodd" d="M14 1H2a1 1 0 0 0-1 1v12a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1V2a1 1 0 0 0-1-1zM2 0a2 2 0 0 0-2 2v12a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V2a2 2 0 0 0-2-2H2z"/>
                    <path fill-rule="evenodd" d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4z"/>
                </svg>
                <small class="ms-2">Добавить копию</small>
            </button>
            <button v-if="canBeDeleted" type="button" class="btn btn-block btn-sm btn-outline-danger zero-height-button d-block ms-auto"
                @click="this.$emit('nodeDeleteClicked')">
                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-x-square" viewBox="0 0 16 16">
                    <path d="M14 1a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1H2a1 1 0 0 1-1-1V2a1 1 0 0 1 1-1h12zM2 0a2 2 0 0 0-2 2v12a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V2a2 2 0 0 0-2-2H2z"/>
                    <path d="M4.646 4.646a.5.5 0 0 1 .708 0L8 7.293l2.646-2.647a.5.5 0 0 1 .708.708L8.707 8l2.647 2.646a.5.5 0 0 1-.708.708L8 8.707l-2.646 2.647a.5.5 0 0 1-.708-.708L7.293 8 4.646 5.354a.5.5 0 0 1 0-.708z"/>
                </svg>
                <small class="ms-2">{{node.isPrimary ? 'Удалить псевдоним' : 'Удалить копию'}}</small>
            </button>
        </div>
    </div>
</template>

<script>
    import BudgetCodesDropdown from '../Codes/BudgetCodesDropdown'

    export default {
        name: 'BudgetAliasTreeNode',
        components: {
            BudgetCodesDropdown
        },
        props: {
            node: Object,
            codesList: Array,
            editMode: Boolean
        },
        emits: [
            'nodeToggleClicked',
            'nodeCopyClicked',
            'nodeDeleteClicked',
        ],
        computed: {
            canBeDeleted: function() {
                return !this.node.isPrimary
                    || (this.node.isPrimary && !this.node.hasCopy && this.node.children.length == 0)
            }
        }
    }
</script>